import Base, { IPluginBaseConfig } from '../base';
import { IAbstractGraph as IGraph } from '@antv/g6-core';
import { Point } from '@antv/g-base';
interface ToolBarConfig extends IPluginBaseConfig {
    handleClick?: (code: string, graph: IGraph) => void;
    getContent?: (graph?: IGraph) => HTMLDivElement | string;
    position?: Point | null;
    zoomSensitivity?: number;
    minZoom?: number;
    maxZoom?: number;
}
export default class ToolBar extends Base {
    constructor(config?: ToolBarConfig);
    getDefaultCfgs(): ToolBarConfig;
    init(): void;
    private bindUndoRedo;
    /**
     * undo 操作
     */
    undo(): void;
    /**
     * redo 操作
     */
    redo(): void;
    /**
     * 根据 Toolbar 上不同类型对图进行操作
     * @param code 操作类型编码
     * @param graph Graph 实例
     */
    private handleDefaultOperator;
    destroy(): void;
}
export {};
